
function generate_DAG(proc::GenericQEDProcess)
    # use a set for deduplication
    particles = Set()
    for fd in feynman_diagrams(proc)
        push!(all_particles, virtual_particles(proc, fd)...)
    end

    # convert to vector
    particles = [particles...]

    external_particles = _pseudo_virtual_particles(proc)
    pairs = particle_pairs(particles)
    triples = total_particle_triples(particles)

    graph = DAG()


end
